import { BaseTask } from "./BaseTask";
import { BehaviorTree } from "./BehaviorTree";
import { GuardEvaluator } from "./GuardEvaluator";
import { Task } from "./Task";
/** The behavior tree itself. */
export declare class BaseBehaviorTree<T> extends BaseTask<T> implements BehaviorTree {
    private rootTask?;
    private object?;
    guardEvaluator: GuardEvaluator<T>;
    constructor(rootTask?: Task, object?: T);
    addChild(child: Task): this;
    getChildCount(): number;
    getChild(index: number): Task;
    getObject(): T;
    setObject(object: T): void;
    childSuccess(runningTask: Task): void;
    childFail(runningTask: Task): void;
    childRunning(runningTask: Task, reporter: Task): void;
    step(): void;
    run(): void;
    resetTask(): void;
    reset(): void;
}
