import { BaseTask } from "./BaseTask";
import { Task } from "./Task";
/**
 * A branch task defines a behavior tree branch,
 * contains logic of starting or running sub-branches and leaves.
 */
export declare abstract class BranchTask<T> extends BaseTask<T> {
    protected children: Task[];
    constructor(...children: Task[]);
    addChild(child: Task): this;
    getChildCount(): number;
    getChild(index: number): Task;
    reset(): void;
}
