"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BaseTask_1 = require("./BaseTask");
/**
 * A branch task defines a behavior tree branch,
 * contains logic of starting or running sub-branches and leaves.
 */
var BranchTask = /** @class */ (function (_super) {
    __extends(BranchTask, _super);
    function BranchTask() {
        var children = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            children[_i] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.children = children;
        return _this;
    }
    BranchTask.prototype.addChild = function (child) {
        this.children.push(child);
        return this;
    };
    BranchTask.prototype.getChildCount = function () {
        return this.children.length;
    };
    BranchTask.prototype.getChild = function (index) {
        return this.children[index];
    };
    BranchTask.prototype.reset = function () {
        _super.prototype.reset.call(this);
        this.children = [];
    };
    return BranchTask;
}(BaseTask_1.BaseTask));
exports.BranchTask = BranchTask;
