"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BaseBehaviorTree_1 = require("./BaseBehaviorTree");
var BaseTask_1 = require("./BaseTask");
var TaskStatus_1 = require("./TaskStatus");
var ChangeData = /** @class */ (function (_super) {
    __extends(ChangeData, _super);
    function ChangeData(mapper, rootTask) {
        var _this = _super.call(this) || this;
        _this.mapper = mapper;
        _this.mapTree = new BaseBehaviorTree_1.BaseBehaviorTree(rootTask);
        return _this;
    }
    ChangeData.prototype.addChild = function (child) {
        throw new Error('This node cannot have any child.');
    };
    ChangeData.prototype.getChildCount = function () {
        return 0;
    };
    ChangeData.prototype.getChild = function (index) {
        throw new Error('This node does not have any child.');
    };
    ChangeData.prototype.run = function () {
        var data = this.getObject();
        var mappedData = this.mapper(data);
        this.mapTree.setObject(mappedData);
        this.mapTree.step();
        var status = this.mapTree.getStatus();
        switch (status) {
            case TaskStatus_1.TaskStatus.Succeeded:
                this.success();
                break;
            case TaskStatus_1.TaskStatus.Failed:
                this.fail();
                break;
            case TaskStatus_1.TaskStatus.Running:
                this.running();
                break;
        }
    };
    ChangeData.prototype.childSuccess = function (runningTask) {
    };
    ChangeData.prototype.childFail = function (runningTask) {
    };
    ChangeData.prototype.childRunning = function (runningTask, reporter) {
    };
    return ChangeData;
}(BaseTask_1.BaseTask));
exports.ChangeData = ChangeData;
