import { BaseTask } from "./BaseTask";
import { Task } from "./Task";
/**
 * A decorator is a wrapper that provides custom behavior for its child.
 * The child can be of any kind (branch task, leaf task or another decorator).
 */
export declare abstract class Decorator<T> extends BaseTask<T> {
    protected child?: Task;
    constructor(child?: Task);
    addChild(child: Task): this;
    getChildCount(): number;
    getChild(index: number): Task;
    run(): void;
    childSuccess(runningTask: Task): void;
    childFail(runningTask: Task): void;
    childRunning(runningTask: Task, reporter: Task): void;
    reset(): void;
}
