import { BranchTask } from "./BranchTask";
import { Task } from "./Task";
export declare abstract class SingleRunningChildBranch<T> extends BranchTask<T> {
    /** The child in the running status or undefined if no child is running. */
    protected runningChild?: Task;
    /** The index of the child currently processed. */
    protected currentChildIndex: number;
    constructor(...children: Task[]);
    childSuccess(runningTask: Task): void;
    childFail(runningTask: Task): void;
    childRunning(runningTask: Task, reporter: Task): void;
    run(): void;
    start(): void;
    cancelRunningChildren(startIndex: number): void;
    resetTask(): void;
    reset(): void;
}
