"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BranchTask_1 = require("./BranchTask");
var SingleRunningChildBranch = /** @class */ (function (_super) {
    __extends(SingleRunningChildBranch, _super);
    function SingleRunningChildBranch() {
        var children = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            children[_i] = arguments[_i];
        }
        var _this = _super.apply(this, children) || this;
        _this.currentChildIndex = 0;
        return _this;
    }
    SingleRunningChildBranch.prototype.childSuccess = function (runningTask) {
        this.runningChild = undefined;
    };
    SingleRunningChildBranch.prototype.childFail = function (runningTask) {
        this.runningChild = undefined;
    };
    SingleRunningChildBranch.prototype.childRunning = function (runningTask, reporter) {
        this.runningChild = runningTask;
        // Return a running status when a child says it's running.
        this.running();
    };
    SingleRunningChildBranch.prototype.run = function () {
        if (this.runningChild !== undefined) {
            this.runningChild.run();
            return;
        }
        if (this.currentChildIndex < this.children.length) {
            this.runningChild = this.children[this.currentChildIndex];
            this.runningChild.setControl(this);
            this.runningChild.start();
            if (!this.runningChild.checkGuard(this)) {
                this.runningChild.fail();
            }
            else {
                this.run();
            }
        }
        else {
            // Should never happen.
            throw new Error('Unknown error.');
        }
    };
    SingleRunningChildBranch.prototype.start = function () {
        _super.prototype.start.call(this);
        this.currentChildIndex = 0;
        this.runningChild = undefined;
    };
    SingleRunningChildBranch.prototype.cancelRunningChildren = function (startIndex) {
        _super.prototype.cancelRunningChildren.call(this, startIndex);
        this.runningChild = undefined;
    };
    SingleRunningChildBranch.prototype.resetTask = function () {
        _super.prototype.resetTask.call(this);
        this.currentChildIndex = 0;
        this.runningChild = undefined;
    };
    SingleRunningChildBranch.prototype.reset = function () {
        _super.prototype.reset.call(this);
        this.currentChildIndex = 0;
        this.runningChild = undefined;
    };
    return SingleRunningChildBranch;
}(BranchTask_1.BranchTask));
exports.SingleRunningChildBranch = SingleRunningChildBranch;
