"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TaskStatus_1 = require("../TaskStatus");
var ParallelResult_1 = require("./ParallelResult");
/**
 * Starts or resumes all children every single step.
 */
var ParallelOrchestratorResume = /** @class */ (function () {
    function ParallelOrchestratorResume() {
    }
    ParallelOrchestratorResume.prototype.execute = function (parallel) {
        parallel.noRunningTasks = true;
        parallel.lastResult = ParallelResult_1.ParallelResult.Running;
        var n = parallel.getChildCount();
        for (parallel.currentChildIndex = 0; parallel.currentChildIndex < n; ++parallel.currentChildIndex) {
            var child = parallel.getChild(parallel.currentChildIndex);
            if (child.getStatus() === TaskStatus_1.TaskStatus.Running) {
                child.run();
            }
            else {
                child.setControl(parallel);
                child.start();
                if (child.checkGuard(parallel)) {
                    child.run();
                }
                else {
                    child.fail();
                }
            }
            if (parallel.lastResult !== ParallelResult_1.ParallelResult.Running) {
                // Current child has finished either with success or fail.
                parallel.cancelRunningChildren(parallel.noRunningTasks ? parallel.currentChildIndex + 1 : 0);
                if (parallel.lastResult !== ParallelResult_1.ParallelResult.Running) {
                    parallel.success();
                }
                else {
                    parallel.fail();
                }
                return;
            }
        }
        parallel.running();
    };
    return ParallelOrchestratorResume;
}());
exports.ParallelOrchestratorResume = ParallelOrchestratorResume;
