"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TaskStatus_1 = require("../TaskStatus");
var ParallelOrchestratorJoin_1 = require("./ParallelOrchestratorJoin");
var ParallelOrchestratorResume_1 = require("./ParallelOrchestratorResume");
var ParallelResult_1 = require("./ParallelResult");
var ParallelPolicySequence = /** @class */ (function () {
    function ParallelPolicySequence() {
    }
    ParallelPolicySequence.prototype.onChildSuccess = function (parallel) {
        if (parallel.orchestrator instanceof ParallelOrchestratorJoin_1.ParallelOrchestratorJoin) {
            if (parallel.noRunningTasks) {
                var lastChild = parallel.getChild(parallel.getChildCount() - 1);
                if (lastChild.getStatus() === TaskStatus_1.TaskStatus.Succeeded) {
                    return ParallelResult_1.ParallelResult.Succeed;
                }
            }
            return ParallelResult_1.ParallelResult.Running;
        }
        if (parallel.orchestrator instanceof ParallelOrchestratorResume_1.ParallelOrchestratorResume) {
            if (parallel.noRunningTasks) {
                if (parallel.currentChildIndex === parallel.getChildCount() - 1) {
                    return ParallelResult_1.ParallelResult.Succeed;
                }
            }
            return ParallelResult_1.ParallelResult.Running;
        }
        throw new Error('Invalid orchestrator.');
    };
    ParallelPolicySequence.prototype.onChildFail = function (parallel) {
        return ParallelResult_1.ParallelResult.Fail;
    };
    return ParallelPolicySequence;
}());
exports.ParallelPolicySequence = ParallelPolicySequence;
