"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var SingleRunningChildBranch_1 = require("../SingleRunningChildBranch");
/**
 * A Selector is a branch task that runs every children until one of them succeeds.
 * If a child task fails, the selector will start and run the next child task.
 */
var Selector = /** @class */ (function (_super) {
    __extends(Selector, _super);
    function Selector() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Selector.prototype.childSuccess = function (runningTask) {
        _super.prototype.childSuccess.call(this, runningTask);
        // Return success status when a child says it succeeded.
        this.success();
    };
    Selector.prototype.childFail = function (runningTask) {
        _super.prototype.childFail.call(this, runningTask);
        if (++this.currentChildIndex < this.children.length) {
            // Run the next child.
            this.run();
        }
        else {
            // All children processed, return failure status.
            this.fail();
        }
    };
    return Selector;
}(SingleRunningChildBranch_1.SingleRunningChildBranch));
exports.Selector = Selector;
