"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Decorator_1 = require("../Decorator");
var TaskStatus_1 = require("../TaskStatus");
/**
 * LoopDecorator is an abstract class providing basic functionalities
 * for concrete looping decorators.
 */
var LoopDecorator = /** @class */ (function (_super) {
    __extends(LoopDecorator, _super);
    function LoopDecorator() {
        var _this = _super.call(this) || this;
        _this.loop = false;
        return _this;
    }
    LoopDecorator.prototype.condition = function () {
        return this.loop;
    };
    LoopDecorator.prototype.run = function () {
        if (this.child === undefined) {
            throw new Error('Invalid status.');
        }
        while (this.condition()) {
            if (this.child.getStatus() === TaskStatus_1.TaskStatus.Running) {
                this.child.run();
            }
            else {
                this.child.setControl(this);
                this.child.start();
                if (this.child.checkGuard(this)) {
                    this.child.run();
                }
                else {
                    this.child.fail();
                }
            }
        }
    };
    LoopDecorator.prototype.childRunning = function (runningTask, reporter) {
        _super.prototype.childRunning.call(this, runningTask, reporter);
        this.loop = false;
    };
    LoopDecorator.prototype.reset = function () {
        _super.prototype.reset.call(this);
        this.loop = false;
    };
    return LoopDecorator;
}(Decorator_1.Decorator));
exports.LoopDecorator = LoopDecorator;
