"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var LoopDecorator_1 = require("./LoopDecorator");
/**
 * An UntilFail decorator will repeat the wrapped task until that task fails,
 * which makes the decorator succeed.
 *
 * Notice that a wrapped task that always succeeds without entering the running
 * status will cause an infinite loop in the current frame.
 */
var UntilFail = /** @class */ (function (_super) {
    __extends(UntilFail, _super);
    function UntilFail() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UntilFail.prototype.childSuccess = function (runningTask) {
        this.loop = true;
    };
    UntilFail.prototype.childFail = function (runningTask) {
        this.success();
        this.loop = false;
    };
    return UntilFail;
}(LoopDecorator_1.LoopDecorator));
exports.UntilFail = UntilFail;
