import { Task } from "../Task";
import { LoopDecorator } from "./LoopDecorator";
/**
 * An UntilSuccess decorator will repeat the wrapped task until that task succeeds,
 * which makes the decorator succeed.
 *
 * Notice that a wrapped task that always fails without entering the running
 * status will cause an infinite loop in the current frame.
 */
export declare class UntilSuccess<T> extends LoopDecorator<T> {
    childSuccess(runningTask: Task): void;
    childFail(runningTask: Task): void;
}
