"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var LeafTask_1 = require("../LeafTask");
var TaskStatus_1 = require("../TaskStatus");
/** Wait is a leaf that keeps running for the specified amount of time then succeeds. */
var Wait = /** @class */ (function (_super) {
    __extends(Wait, _super);
    function Wait(seconds) {
        var _this = _super.call(this) || this;
        _this.seconds = seconds;
        _this.elapsed = 0;
        return _this;
    }
    Wait.prototype.start = function () {
        _super.prototype.start.call(this);
        this.elapsed = 0;
    };
    Wait.prototype.execute = function () {
        this.elapsed += this.getObject().delta;
        if (this.elapsed >= this.seconds) {
            return TaskStatus_1.TaskStatus.Succeeded;
        }
        else {
            return TaskStatus_1.TaskStatus.Running;
        }
    };
    Wait.prototype.reset = function () {
        _super.prototype.reset.call(this);
        this.seconds = 0;
        this.elapsed = 0;
    };
    return Wait;
}(LeafTask_1.LeafTask));
exports.Wait = Wait;
